package net.phaedra.webapp.examples;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import net.phaedra.wicket.crud.EditPanel;

import org.apache.commons.io.IOUtils;
import org.apache.wicket.ResourceReference;
import org.apache.wicket.extensions.markup.html.image.resource.ThumbnailImageResource;
import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.markup.html.image.Image;
import org.apache.wicket.markup.html.image.resource.DynamicImageResource;
import org.apache.wicket.model.Model;

/**
 * @author ildella
 */
public class ImageExamples extends WebPage {

   public ImageExamples() {
      final Model<String> model = new Model("capelli.jpg");
      add(new Image("modelImage", model));
      add(new Image("resourceReferenceImage", new ResourceReference(EditPanel.class, "save.gif")));
      DynamicImageResource imageResource = new DynamicImageResource() {

         @Override
         protected byte[] getImageData() {
            final File file = new File("static", model.getObject());
            System.out.println("image load from path: " + file.getAbsolutePath());
            try {
               return IOUtils.toByteArray(new FileInputStream(file));
            } catch (final FileNotFoundException e) {
               e.printStackTrace();
            } catch (final IOException e) {
               e.printStackTrace();
            }
            return new byte[0];
         }
      };
      add(new Image("resourceModelImage", new ThumbnailImageResource(imageResource, 100)));
   }
}
